/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.exporter;

import java.util.Set;

import it.eng.spago4q.metadata.S4qEDataSource;
import it.eng.spago4q.metadata.S4qEDataSourceParameter;
import it.eng.spago4q.metadata.S4qESourceType;

import com.thoughtworks.xstream.XStream;

public class DataSourceExporter extends AbstractExporter{
	
	public String exportDataSource(final S4qEDataSource dataSource){
		return getXStream().toXML(dataSource);
	}
	
	public String exportDataSourceSet(final Set<S4qEDataSource> dataSourceSet){
		return getXStream().toXML(dataSourceSet);
	}
	
	public S4qEDataSource importDataSource(final String xml){
		return (S4qEDataSource)getXStream().fromXML(xml);
	}

	public Set<S4qEDataSource> importDataSourceSet(final String xml){
		return (Set<S4qEDataSource>)getXStream().fromXML(xml);
	}
	
	public void setUp(final XStream xstreamPar){
		xstreamPar.alias("dataSource", S4qEDataSource.class);
		xstreamPar.alias("dataSourceParameter", S4qEDataSourceParameter.class);
		
		xstreamPar.aliasField("sourceType", S4qEDataSource.class, "s4qESourceType");
		xstreamPar.aliasField("dataSourceParameters", S4qEDataSource.class, "s4qEDataSourceParameters");

		xstreamPar.omitField(S4qEDataSource.class, "s4qEOperations");
		xstreamPar.omitField(S4qEDataSource.class, "idDataSource");
		
		xstreamPar.omitField(S4qESourceType.class, "idSourceType");
		xstreamPar.omitField(S4qESourceType.class, "s4qEDataSources");
		xstreamPar.omitField(S4qEDataSourceParameter.class, "idDataSourceParameter");
	}

}
