/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.extractors;

import java.util.Date;

import it.eng.spago.error.EMFUserError;
import it.eng.spago4q.bo.ELog;
import it.eng.spago4q.dao.DAOFactory;
import it.eng.spago4q.dao.IES4QFKDAO;

public class LogWriter {

	private ELog log;
	private IES4QFKDAO eLogDao;

	public LogWriter() throws EMFUserError {
		log = new ELog();
		eLogDao = (IES4QFKDAO) DAOFactory.getDAO("ELogDAO");
	}

	protected void writeExtractedItems(final Integer processId,
			final Integer operationId, final Integer extractedItem,
			final Date operationDate, final Date executionDate,
			final String archivePath) throws EMFUserError {
		log.setProcessId(processId);
		log.setOperationId(operationId);
		log.setExtracted(extractedItem);
		log.setOperationDate(operationDate);
		log.setExecutionDate(executionDate);
		log.setArchivePath(archivePath);
		log.setCompleted(false);

		Integer logId = eLogDao.insertObject(log);

		log.setIdLog(logId);
	}

	protected Integer getLogId() {
		Integer toReturn = null;
		if (log != null) {
			toReturn = log.getIdLog();
		}
		return toReturn;
	}

	protected void writeMappingError(int rejected, String rejectedPath)
			throws EMFUserError {
		log.setRejected(rejected);
		log.setRejectedArchivePath(rejectedPath);
		eLogDao.modifyObject(log);
	}

	protected void wirteInsertedItems(final Integer insertedItem)
			throws EMFUserError {
		log.setInserted(insertedItem);
		log.setCompleted(true);
		eLogDao.modifyObject(log);
	}
}
