/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.extractors;

import it.eng.spago4q.bo.EOperation;
import it.eng.spago4q.extractors.bo.GenericItemInterface;
import it.eng.spago4q.extractors.utilities.OperationUtil;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class MappingErrorManager {

	private List<GenericItemInterface> genericItemList;
	private List<String> errorMessage;

	public MappingErrorManager() {
		genericItemList = new ArrayList<GenericItemInterface>();
		errorMessage = new ArrayList<String>();
	}

	public void addError(String operationFieldName, String interfaceFieldName,
			String message, GenericItemInterface genericItem) {
		genericItemList.add(genericItem);
		if (operationFieldName != null && interfaceFieldName != null) {
			errorMessage.add("Generic Item Field: [" + operationFieldName
					+ "] - Interface Item Field :[" + interfaceFieldName
					+ "] - Message: [" + message + "]");
		} else {
			if (operationFieldName != null) {
				errorMessage.add("Generic Item Field: [" + operationFieldName
						+ "] - Message: [" + message + "]");
			} else {
				errorMessage.add("Message: [" + message+"]");
			}
		}
	}

	public int getNumberOfRejected() {
		int toReturn = 0;
		if (errorMessage != null) {
			toReturn = errorMessage.size();
		}
		return toReturn;
	}

	public String createRejectedArchive(final Date executionDate,
			final EOperation operation, final String extractorDir) {
		return OperationUtil.createRejectedArchive(genericItemList,
				errorMessage, executionDate, operation, extractorDir);
	}

	public void print() {
		for (int i = 0; i < genericItemList.size(); i++) {
			System.out.println(genericItemList.get(i));
			System.out.println(errorMessage.get(i));
		}
	}
}
