/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.extractors.bo;

import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.configuration.FileCreatorConfiguration;

import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import junit.framework.TestCase;

public class GenericItemUtilTest extends TestCase {

	@Override
	protected void setUp() throws Exception {
		super.setUp();
		ClassLoader loader = this.getClass().getClassLoader();
		URL xmlUrl = loader.getResource("master.xml");
		System.setProperty("AF_CONFIG_FILE", xmlUrl.getPath());
		ConfigSingleton.setConfigurationCreation(new FileCreatorConfiguration(
				ConfigSingleton.getRootPath()));
	}

	public GenericItemUtilTest(final String name) {
		super(name);
	}

	public void testGenericItemListToSourceBean() {
		List<GenericItemInterface> genericItemList = new ArrayList<GenericItemInterface>();
		GenericItem g1 = new GenericItem();
		g1.setValue("prova11", "provax");
		g1.setValue("prova12", "provay");
		g1.setValue("prova13", "prova1");

		GenericItem g2 = new GenericItem();
		g2.setValue("prova21", "provaa");
		g2.setValue("prova22", "provab");
		g2.setValue("prova23", "prova2");

		genericItemList.add(g1);
		genericItemList.add(g2);
		SourceBean result = null;

		try {
			result = GenericItemUtil
					.genericItemListToSourceBean(genericItemList);
		} catch (Exception e) {
			fail();
		}
	}
	
	public void testGenericItemListWithErrorsToSourceBean() {
		List<GenericItemInterface> genericItemList = new ArrayList<GenericItemInterface>();
		List<String> errorMessages = new ArrayList<String>();
		GenericItem g1 = new GenericItem();
		g1.setValue("prova11", "prova1");
		g1.setValue("prova12", "prova1");
		g1.setValue("prova13", "prova1");

		GenericItem g2 = new GenericItem();
		g2.setValue("prova21", "prova2");
		g2.setValue("prova22", "prova2");
		g2.setValue("prova23", "prova2");

		genericItemList.add(g1);
		genericItemList.add(g2);
		
		errorMessages.add("g1 error1");
		errorMessages.add("g2 error2");
		SourceBean result = null;

		try {
			result = GenericItemUtil
					.genericItemListWithErrorsToSourceBean(genericItemList, errorMessages);
		} catch (Exception e) {
			fail();
		}
	}

}
